/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
function BrowserStorage(category) {
  this.ls = window.localStorage
  this.category = category
}

BrowserStorage.prototype.set = function(key, val) {
  this.ls.setItem(this.category + key, val)
}

BrowserStorage.prototype.get = function(key) {
  v = this.ls.getItem(this.category + key)
  if(v == null) v = ""
  return v
}

BrowserStorage.prototype.remove = function(key) {
  this.ls.removeItem(this.category + key)
}

BrowserStorage.prototype.removeAll = function() {
  key = new Array()
  for(i = 0; i < this.ls.length; i++){
    k = this.ls.key(i)
    if(k.indexOf(this.category) == 0)
      key.push(k)
  }
  for(i = 0; i < key.length; i++)
    this.ls.removeItem(key[i])
}

BrowserStorage.prototype.removeAllLocalStrage = function() {
  if(!confirm("localStrageΥǡޤǤ?"))
    return
  key = new Array()
  for(i = 0; i < this.ls.length; i++)
    key[i] = this.ls.key(i)
  for(i = 0; i < key.length; i++)
    this.ls.removeItem(key[i])
}

BrowserStorage.prototype.keyList = function() {
  a = new Array()
  j = 0
  for(i = 0; i < this.ls.length; i++){
    s = this.ls.key(i)
    if(s.indexOf(this.category) == 0)
      a[j++] = s.substring(this.category.length)
  }
  return a.sort()
}

BrowserStorage.prototype.debug = function() {
  s = "length=" + this.ls.length + "\n"
  for(i = 0; i < this.ls.length; i++)
    s += this.ls.key(i) + "\n" + this.ls.getItem(this.ls.key(i)) + "\n"
  alert(s)
}
